lib: plugin-so.c: ERROR and INFO level messages logged in callee
[babeltrace.git] / tests / utils / utils.sh
CommitLineData
644e0364
MJ
1#!/bin/bash
2
3# Copyright (c) 2019 Michael Jeanson <mjeanson@efficios.com>
4# Copyright (C) 2019 Philippe Proulx <pproulx@efficios.com>
5#
6# This program is free software; you can redistribute it and/or modify
7# it under the terms of the GNU General Public License as published by
8# the Free Software Foundation; under version 2 of the License.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License along
16# with this program; if not, write to the Free Software Foundation, Inc.,
17# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
18
19# This file is meant to be sourced at the start of shell script-based tests.
20
21
22# Error out when encountering an undefined variable
23set -u
24
25scriptdir="$(dirname "${BASH_SOURCE[0]}")"
26
5058d31b
JR
27# The OS on which we are running. See [1] for possible values of 'uname -s'.
28# We do a bit of translation to ease our life down the road for comparison.
29# Export it so that called executables can use it.
30# [1] https://en.wikipedia.org/wiki/Uname#Examples
31if [ "x${BT_OS_TYPE:-}" = "x" ]; then
32 BT_OS_TYPE="$(uname -s)"
33 case "$BT_OS_TYPE" in
34 MINGW*)
35 BT_OS_TYPE="mingw"
36 ;;
37 Darwin)
38 BT_OS_TYPE="darwin"
39 ;;
40 Linux)
41 BT_OS_TYPE="linux"
42 ;;
df9db467
JR
43 CYGWIN*)
44 BT_OS_TYPE="cygwin"
45 ;;
5058d31b
JR
46 *)
47 BT_OS_TYPE="unsupported"
48 ;;
49 esac
50fi
51export BT_OS_TYPE
52
644e0364
MJ
53# Allow overriding the source and build directories
54if [ "x${BT_TESTS_SRCDIR:-}" = "x" ]; then
4881a20e 55 BT_TESTS_SRCDIR="$scriptdir/.."
644e0364
MJ
56fi
57export BT_TESTS_SRCDIR
58
59if [ "x${BT_TESTS_BUILDDIR:-}" = "x" ]; then
4881a20e 60 BT_TESTS_BUILDDIR="$scriptdir/.."
644e0364
MJ
61fi
62export BT_TESTS_BUILDDIR
63
64# By default, it will not source tap.sh. If you to tap output directly from
65# the test script, define the 'SH_TAP' variable to '1' before sourcing this
66# script.
67if [ "x${SH_TAP:-}" = x1 ]; then
1d970e04 68 # shellcheck source=./tap/tap.sh
644e0364
MJ
69 . "${BT_TESTS_SRCDIR}/utils/tap/tap.sh"
70fi
71
72# Allow overriding the babeltrace2 executables
73if [ "x${BT_TESTS_BT2_BIN:-}" = "x" ]; then
4881a20e 74 BT_TESTS_BT2_BIN="$BT_TESTS_BUILDDIR/../src/cli/babeltrace2"
5058d31b 75 if [ "$BT_OS_TYPE" = "mingw" ]; then
27e2c58d
JR
76 BT_TESTS_BT2_BIN="${BT_TESTS_BT2_BIN}.exe"
77 fi
644e0364
MJ
78fi
79export BT_TESTS_BT2_BIN
80
81if [ "x${BT_TESTS_BT2LOG_BIN:-}" = "x" ]; then
4881a20e 82 BT_TESTS_BT2LOG_BIN="$BT_TESTS_BUILDDIR/../src/cli/babeltrace2-log"
5058d31b 83 if [ "$BT_OS_TYPE" = "mingw" ]; then
27e2c58d
JR
84 BT_TESTS_BT2LOG_BIN="${BT_TESTS_BT2LOG_BIN}.exe"
85 fi
644e0364
MJ
86fi
87export BT_TESTS_BT2LOG_BIN
88
89# TODO: Remove when bindings/python/bt2/test_plugin.py is fixed
90BT_PLUGINS_PATH="${BT_TESTS_BUILDDIR}/../src/plugins"
91
92# Allow overriding the babeltrace2 plugin path
93if [ "x${BT_TESTS_BABELTRACE_PLUGIN_PATH:-}" = "x" ]; then
94 BT_TESTS_BABELTRACE_PLUGIN_PATH="${BT_PLUGINS_PATH}/ctf:${BT_PLUGINS_PATH}/utils:${BT_PLUGINS_PATH}/text"
95fi
96
b14c7bf1
MJ
97if [ "x${BT_TESTS_PROVIDER_DIR:-}" = "x" ]; then
98 BT_TESTS_PROVIDER_DIR="${BT_TESTS_BUILDDIR}/../src/python-plugin-provider/.libs"
99fi
100
644e0364
MJ
101# Allow overriding the babeltrace2 executables
102if [ "x${BT_TESTS_PYTHONPATH:-}" = "x" ]; then
103 BT_TESTS_PYTHONPATH="${BT_TESTS_BUILDDIR}/../src/bindings/python/bt2/build/build_lib"
104fi
105
106
107### External Tools ###
108if [ "x${BT_TESTS_AWK_BIN:-}" = "x" ]; then
109 BT_TESTS_AWK_BIN="awk"
110fi
111export BT_TESTS_AWK_BIN
112
113if [ "x${BT_TESTS_GREP_BIN:-}" = "x" ]; then
114 BT_TESTS_GREP_BIN="grep"
115fi
116export BT_TESTS_GREP_BIN
117
118if [ "x${BT_TESTS_PYTHON_BIN:-}" = "x" ]; then
119 BT_TESTS_PYTHON_BIN="python3"
120fi
121export BT_TESTS_PYTHON_BIN
122
123if [ "x${BT_TESTS_SED_BIN:-}" = "x" ]; then
124 BT_TESTS_SED_BIN="sed"
125fi
126export BT_TESTS_SED_BIN
127
128
129# Data files path
130BT_TESTS_DATADIR="${BT_TESTS_SRCDIR}/data"
131BT_CTF_TRACES_PATH="${BT_TESTS_DATADIR}/ctf-traces"
132BT_DEBUG_INFO_PATH="${BT_TESTS_DATADIR}/debug-info"
133
134
135### Diff Functions ###
136
53cc240b
MJ
137# Checks the difference between the content of the file with path "$1"
138# and the output of the CLI when called with the rest of arguments
139# to this function.
644e0364
MJ
140#
141# Returns 0 if there's no difference, and 1 if there is, also printing
142# said difference to the standard error.
143bt_diff_cli() {
53cc240b
MJ
144 local expected_file="$1"
145 shift 1
146 local args=("$@")
147
644e0364
MJ
148 local temp_output_file
149 local temp_diff
150 local ret=0
151
152 temp_output_file="$(mktemp)"
153 temp_diff="$(mktemp)"
154
155 # Run the CLI to get a detailed file. Strip any \r present due to
156 # Windows (\n -> \r\n). "diff --string-trailing-cr" is not used since it
157 # is not present on Solaris.
1d970e04 158 run_python_bt2 "$BT_TESTS_BT2_BIN" "${args[@]}" | tr -d "\r" > "$temp_output_file"
644e0364
MJ
159
160 # Compare output with expected output
1af7795b 161 if ! diff -u "$temp_output_file" "$expected_file" 2>/dev/null >"$temp_diff"; then
53cc240b 162 echo "ERROR: for '${args[*]}': actual and expected outputs differ:" >&2
644e0364
MJ
163 cat "$temp_diff" >&2
164 ret=1
165 fi
166
167 rm -f "$temp_output_file" "$temp_diff"
168
169 return $ret
170}
171
53cc240b
MJ
172# Checks the difference between the content of the file with path "$1"
173# and the output of the CLI when called on the directory path "$2" with
174# the arguments '-c sink.text.details' and the rest of the arguments to
175# this function.
644e0364
MJ
176#
177# Returns 0 if there's no difference, and 1 if there is, also printing
178# said difference to the standard error.
179bt_diff_details_ctf_single() {
53cc240b
MJ
180 local expected_file="$1"
181 local trace_dir="$2"
182 shift 2
183 local extra_details_args=("$@")
644e0364
MJ
184
185 # Compare using the CLI with `sink.text.details`
53cc240b 186 bt_diff_cli "$expected_file" "$trace_dir" "-c" "sink.text.details" "${extra_details_args[@]}"
644e0364
MJ
187}
188
189# Calls bt_diff_details_ctf_single(), except that "$1" is the path to a
190# program which generates the CTF trace to compare to. The program "$1"
191# receives the path to a temporary, empty directory where to write the
192# CTF trace as its first argument.
193bt_diff_details_ctf_gen_single() {
194 local ctf_gen_prog_path="$1"
195 local expected_file="$2"
53cc240b
MJ
196 shift 2
197 local extra_details_args=("$@")
644e0364
MJ
198
199 local temp_trace_dir
200 local ret
201
202 temp_trace_dir="$(mktemp -d)"
203
204 # Run the CTF trace generator program to get a CTF trace
205 if ! "$ctf_gen_prog_path" "$temp_trace_dir" 2>/dev/null; then
206 echo "ERROR: \"$ctf_gen_prog_path\" \"$temp_trace_dir\" failed" >&2
207 rm -rf "$temp_trace_dir"
208 return 1
209 fi
210
211 # Compare using the CLI with `sink.text.details`
53cc240b 212 bt_diff_details_ctf_single "$expected_file" "$temp_trace_dir" "${extra_details_args[@]}"
644e0364
MJ
213 ret=$?
214 rm -rf "$temp_trace_dir"
215 return $ret
216}
217
218
219### Functions ###
220
221check_coverage() {
222 coverage run "$@"
223}
224
225# Execute a shell command in the appropriate environment to have access to the
226# bt2 Python bindings.
227run_python_bt2() {
228 local lib_search_var
229 local lib_search_path
230
0408934a
SM
231 local main_lib_path="${BT_TESTS_BUILDDIR}/../src/lib/.libs"
232
644e0364 233 # Set the library search path so the python interpreter can load libbabeltrace2
df9db467 234 if [ "$BT_OS_TYPE" = "mingw" ] || [ "$BT_OS_TYPE" = "cygwin" ]; then
644e0364 235 lib_search_var="PATH"
b14c7bf1 236 lib_search_path="${main_lib_path}:${PATH:-}"
5058d31b
JR
237 elif [ "$BT_OS_TYPE" = "darwin" ]; then
238 lib_search_var="DYLD_LIBRARY_PATH"
b14c7bf1 239 lib_search_path="${main_lib_path}:${DYLD_LIBRARY_PATH:-}"
644e0364
MJ
240 else
241 lib_search_var="LD_LIBRARY_PATH"
b14c7bf1 242 lib_search_path="${main_lib_path}:${LD_LIBRARY_PATH:-}"
644e0364
MJ
243 fi
244
245 env \
246 BABELTRACE_PYTHON_BT2_NO_TRACEBACK=1 \
247 BABELTRACE_PLUGIN_PATH="${BT_TESTS_BABELTRACE_PLUGIN_PATH}" \
b14c7bf1 248 LIBBABELTRACE2_PLUGIN_PROVIDER_DIR=${BT_TESTS_PROVIDER_DIR} \
644e0364
MJ
249 BT_CTF_TRACES_PATH="${BT_CTF_TRACES_PATH}" \
250 BT_PLUGINS_PATH="${BT_PLUGINS_PATH}" \
251 PYTHONPATH="${BT_TESTS_PYTHONPATH}:${BT_TESTS_SRCDIR}/utils/python" \
252 "${lib_search_var}"="${lib_search_path}" \
253 "$@"
254}
255
256# Set the environment and run python tests in the directory.
257#
258# $1 : The directory containing the python test scripts
259# $2 : The pattern to match python test script names (optional)
644e0364
MJ
260run_python_bt2_test() {
261 local test_dir="$1"
a818a617 262 local test_pattern="${2:-'*'}" # optional, if none default to "*"
644e0364
MJ
263
264 local ret
265 local test_runner_args=()
266
267 test_runner_args+=("$test_dir")
268 if [ "x${test_pattern}" != "x" ]; then
269 test_runner_args+=("${test_pattern}")
270 fi
271
272 if test "x${BT_TESTS_COVERAGE:-}" = "x1"; then
273 python_exec="check_coverage"
274 else
275 python_exec="${BT_TESTS_PYTHON_BIN}"
276 fi
277
278 run_python_bt2 \
279 "${python_exec}" \
280 "${BT_TESTS_SRCDIR}/utils/python/testrunner.py" \
a818a617
FD
281 --pattern "$test_pattern" \
282 "$test_dir" \
283
644e0364
MJ
284 ret=$?
285
286 if test "x${BT_TESTS_COVERAGE_REPORT:-}" = "x1"; then
287 coverage report -m
288 fi
289
290 if test "x${BT_TESTS_COVERAGE_HTML:-}" = "x1"; then
291 coverage html
292 fi
293
294 return $ret
295}
This page took 0.03625 seconds and 4 git commands to generate.